<?php

    /**
     * Created by PhpStorm.
     * User: roger
     * Date: 12.07.17
     * Time: 12:50
     */

    namespace wpes;

    abstract class Wpes {

        public static function MailEncrypt($string, $back = 0, $method = 1) {

            $out = '';

            if ($method === 'ascii') {

                for ($a = 0; $a < strlen($string); $a ++) {

                    $out .= '&#'.ord(substr($string, $a, 1)).';';

                }

            } else {

                for ($a = 0; $a <strlen($string); $a ++) {

                    $charValue = ord(substr($string,$a,1));
                    $charValue+= intval($method)*($back?-1:1);

                    $out .= chr($charValue);

                }

            }

            return $out;

        } // public function MailEncrypt($string, $back = 0, $method = 1)

        public static function match($match) {
	
			if (preg_match('/^mailto:/i', $match[0])) {
		
				return '" onclick="wpes_linkTo_UnCryptMailto(\''.self::MailEncrypt(preg_replace('/^mailto:/i', '', $match[0])).'\');';
		
			} else if (!preg_match('/^value/i', $match[0])) {
		
				return preg_replace('/@/', '(at)', $match[0]);
		
			} else return $match[0];

        } // function match($match)

        public static function filter($string) {

            if (strpos($string, '@') === false) return $string;

            $regexp = '/(?:value=(\"|\'))?(?:mailto:)?(?:[-!#$%&*+\/=?^_`.{|}~\w\x80-\xFF]+|".*?")\@(?:[-a-z0-9\x80-\xFF]+(\.[-a-z0-9\x80-\xFF]+)*\.[a-z]+|\[[\d.a-fA-F:]+\])/xi';
            //$regexp = '/(?:mailto:)?(?:[-!#$%&*+\/=?^_`.{|}~\w\x80-\xFF]+|".*?")\@(?:[-a-z0-9\x80-\xFF]+(\.[-a-z0-9\x80-\xFF]+)*\.[a-z]+|\[[\d.a-fA-F:]+\])/xi';

            return preg_replace_callback($regexp, array('wpes\wpes', 'match'), $string);

        } // public static function filter($string)

    } // class wpes